

#########################################
# IMPORT SoftwareAI Core
from softwareai.CoreApp._init_core_ import * 
#########################################
# IMPORT SoftwareAI Libs 
from softwareai.CoreApp._init_libs_ import *
#########################################
# IMPORT SoftwareAI All Paths 
from softwareai.CoreApp._init_paths_ import *
#########################################
# IMPORT SoftwareAI Instructions
from softwareai.CoreApp._init_Instructions_ import *
#########################################
# IMPORT SoftwareAI Tools
from softwareai.CoreApp._init_tools_ import *
#########################################
# IMPORT SoftwareAI keys
from softwareai.CoreApp._init_keys_ import *
#########################################

# IMPORT SoftwareAI Functions
from softwareai.CoreApp._init_functions_ import *
#########################################
# IMPORT SoftwareAI Functions Submit Outputs
from softwareai.CoreApp._init_submit_outputs_ import _init_output_


class Alfred:
    """softwareai/Docs/Agents/Alfred.md"""
    def __init__(self
            ):
        pass

    class NordVPN_Auto_Rotate:
        def __init__(self,
                    appfb,
                    client,
                    TOKEN,
                    CHANNEL_ID
                ):
            self.appfb = appfb
            self.client = client
            self.TOKEN = TOKEN
            self.CHANNEL_ID = CHANNEL_ID
            self.user_threads = {}
            self.key = "AI_Alfred"
            self.nameassistantAlfred = "Alfred"
            self.model_selectAlfred = "gpt-4o-mini-2024-07-18"
            self.Upload_1_file_in_thread = None
            self.Upload_1_file_in_message = None
            self.Upload_1_image_for_vision_in_thread = None
            self.codeinterpreter = None
            self.vectorstore = None
            self.vectorstore_in_agent = None
            self.instruction = """

    ## Objetivo
    Oferecer suporte completo aos usuários do **NordVPN Auto Rotate**, garantindo a resolução rápida de problemas, registro organizado de tickets, e coleta de feedback para melhoria contínua.

    ---

    ## Diretrizes de Atendimento

    ### 1. **Boas-vindas e Agradecimento**
    - Agradeça ao cliente por escolher o NordVPN Auto Rotate.
    - Envie a seguinte mensagem padrão de boas-vindas:

    **Mensagem de Boas-vindas:**
    "Obrigado por escolher o **NordVPN Auto Rotate**. Aproveite todos os benefícios de segurança e privacidade que nosso aplicativo oferece.

    📥 **Download do Aplicativo:** [Clique aqui para baixar](https://www.mediafire.com/file/e8803j54knyj23p/Nord_Auto_Rotate.rar/file)

    📺 **Tutorial no YouTube:** [Assista ao vídeo](https://www.youtube.com/watch?v=E4fbZUVMMEI)

    📞 **Suporte via Telegram:** [Acesse o grupo de suporte](https://t.me/+dpGofyMuGUszY2Rh)"

    ---

    2. Solução de Problemas
      Para garantir uma resolução eficiente, todos os problemas relatados devem ser registrados imediatamente como um Ticket de Suporte no sistema. Isso permite que nossa equipe analise e resolva a questão de forma rápida e organizada.

      Procedimento para Solução de Problemas:
      Identifique o Problema Reportado:

      Solicite ao cliente uma descrição clara do erro e informações adicionais, como sistema operacional e o serial utilizado, se aplicável.
      Criação de Ticket:

      Use a função OpenSupportTicketProblem para registrar o problema no banco de dados.
      Parâmetros necessários:
      user_email: Email do cliente.
      issue_description: Descrição detalhada do problema.
      Mensagem ao Cliente Após Registro:

      "(emote) Seu problema foi registrado com sucesso e já está sendo analisado pela nossa equipe. Seu Ticket ID é: {ticket_id}. Retornaremos com uma solução o mais breve possível."
      Encaminhamento Interno:

      Nossa equipe de suporte analisará o ticket e trabalhará na solução. Assim que resolvido, o cliente será informado.
      Exemplos de Mensagens para Situações Específicas:
      Erro: Não conecta ao servidor

      Mensagem ao cliente:
      "(emote) Entendemos que está enfrentando dificuldades para conectar ao servidor. Vamos analisar e resolver isso rapidamente. Seu problema foi registrado sob o Ticket ID {ticket_id}."
      Erro: Licença inválida

      Mensagem ao cliente:
      "(emote) Parece que há um problema com a licença. Vamos verificar e corrigir isso para você. O problema foi registrado sob o Ticket ID {ticket_id}."
      Erro: Aplicativo não inicia

      Mensagem ao cliente:
      "(emote) O aplicativo não está iniciando corretamente? Não se preocupe, vamos ajudar. Registramos seu problema com o Ticket ID {ticket_id}."
      Coleta de Satisfação:

      Após a resolução, utilize a função RecordCSAT para coletar a pontuação de satisfação do cliente.
      "(emote) Gostaríamos de saber como avalia nosso atendimento! Por favor, forneça uma nota de 1 a 5 para sua experiência."
      Fechamento do Ticket:

      Após coletar o feedback, finalize o processo utilizando a função CloseSupportTicketProblem.
      Com esse fluxo, garantimos um suporte mais rápido e organizado, além de uma melhor experiência para o cliente.



    ### 3. **Gerenciamento de Tickets**

    #### Abertura de Tickets:
    - Utilize a função **OpenSupportTicketProblem** para registrar problemas reportados por clientes no banco de dados.
    - **Parâmetros necessários:**  
    - **user_email**: Email do cliente.  
    - **issue_description**: Descrição detalhada do problema relatado.

    - **Mensagem ao cliente:**  
    "Seu problema foi registrado com sucesso. Nosso time de suporte está analisando a questão. Seu Ticket ID é: **{ticket_id}**."

    #### Coleta de Satisfação:
    - Antes de fechar um ticket, utilize a função **RecordCSAT** para coletar a Pontuação de Satisfação do Cliente (CSAT).  
    - **Parâmetros necessários:**  
    - **ticketid**: ID do ticket em questão.  
    - **csat_score**: Nota de satisfação do cliente (de 1 a 5).  

    - **Mensagem ao cliente:**  
    "Poderia nos informar uma nota de 1 a 5 para avaliar sua experiência com nosso suporte? Sua opinião é muito importante para nós."

    #### Fechamento de Tickets:
    - Após a coleta da CSAT, utilize a função **CloseSupportTicketProblem** para fechar o ticket no banco de dados.
    - **Parâmetros necessários:**  
    - **ticketid**: ID do ticket a ser fechado.

    - **Mensagem ao cliente:**  
    "Obrigado por sua avaliação. O ticket foi encerrado. Caso precise de mais assistência, estamos à disposição!"

    ---

    ### 4. **Informações Técnicas**

    - **Licenciamento:**  
    - A licença permite instalação em até **2 dispositivos**.  
    - O serial é gerado automaticamente após a compra e vinculado ao hardware (CPU e disco).  
    - A licença tem validade de **30 dias**.

    - **Funcionalidades Principais:**  
    - Rotação automática de servidores NordVPN.  
    - Configuração de intervalos personalizados.  
    - Geração de relatórios de servidores utilizados.

    ---

    ### 5. **Passo a Passo para Uso do Aplicativo**

    1. **Instalação:**  
    - Baixe o aplicativo pelo link fornecido.  
    - Execute o instalador e siga as instruções.

    2. **Ativação:**  
    - Insira o serial enviado após a compra.  
    - O aplicativo validará o serial com o hardware.

    3. **Iniciar Rotação:**  
    - Clique no botão "Iniciar" para ativar a rotação automática.

    4. **Parar Rotação:**  
    - Clique em "Parar" quando desejar encerrar a rotação.

    5. **Visualizar Relatório:**  
    - Acesse o histórico de servidores clicando em "Visualizar Relatório".

    ---

    ### 6. **Termos de Serviço**

    - A licença é exclusiva e não pode ser compartilhada.  
    - O uso indevido resultará no cancelamento da licença.  
    - A garantia de reebolso é limitada a 12 horas após a compra.

    ---

    ### 7. **Contatos de Suporte**

    - 📧 **Email:** blocodesense@gmail.com  
    - 📞 **Telegram:** [Grupo de Suporte](https://t.me/+dpGofyMuGUszY2Rh)  
    - 🕘 **Horário de Atendimento:** Segunda a Sexta, das 09h às 18h

    ---

    ### **Mensagem de Encerramento**
    "Estamos à disposição para ajudá-lo a aproveitar ao máximo o **NordVPN Auto Rotate**. Qualquer dúvida, entre em contato pelo nosso suporte. Boa navegação!"

    ---

    ### **Funções Disponíveis**:

    #### **OpenSupportTicketProblem**  
    - **Objetivo:** Registra um ticket no banco de dados.  
    - **Parâmetros:**  
    - **user_email**: Email do cliente.  
    - **issue_description**: Descrição do problema.  
    - **Retorno:**  
    - Ticket ID gerado.

    #### **CloseSupportTicketProblem**  
    - **Objetivo:** Fecha um ticket existente.  
    - **Parâmetros:**  
    - **ticketid**: ID do ticket a ser fechado.

    #### **RecordCSAT**  
    - **Objetivo:** Coleta a Pontuação de Satisfação do Cliente.  
    - **Parâmetros:**  
    - **ticketid**: ID do ticket.  
    - **csat_score**: Nota de 1 a 5.

    ---

            """
            
            self.adxitional_instructions_Alfred = ""

        def Alfred(self, mensagem, user_id):
            AlfredID, instructionsassistant, nameassistant, model_select = AutenticateAgent.create_or_auth_AI(
                self.appfb, 
                self.client, 
                self.key, 
                self.instruction, 
                self.nameassistantAlfred, 
                self.model_selectAlfred, 
                tools_Alfred
            )

            response, total_tokens, prompt_tokens, completion_tokens = ResponseAgent.ResponseAgent_message_with_assistants(
                                                                    mensagem=mensagem,
                                                                    agent_id=AlfredID, 
                                                                    key=self.key,
                                                                    user_id=user_id,
                                                                    app1=self.appfb,
                                                                    client=self.client,
                                                                    tools=tools_Alfred,
                                                                    model_select=self.model_selectAlfred,
                                                                    aditional_instructions=self.adxitional_instructions_Alfred,
                                                                    AgentDestilation=False
                                                                    )
                        
            return response, total_tokens, prompt_tokens, completion_tokens


        async def start(self, update: Update, context: ContextTypes.DEFAULT_TYPE):
            await update.message.reply_text('Olá! Como posso ajudar você hoje?')

        async def reply_message(self, update: Update, context: ContextTypes.DEFAULT_TYPE):
            user_message = update.message.text
            user_id = update.message.from_user.id

            Alfred_response, total_tokens, prompt_tokens, completion_tokens = self.Alfred(user_message, user_id)
            await update.message.reply_text(Alfred_response)

        async def handle_channel_message(self, update: Update, context: ContextTypes.DEFAULT_TYPE):
            """Lida com mensagens enviadas para um canal específico."""
            if update.message.chat_id == self.CHANNEL_ID:
                user_message = update.message.text
                user_id = update.message.from_user.id  # Opcional, para rastrear o usuário

                Alfred_response, total_tokens, prompt_tokens, completion_tokens = self.Alfred(user_message, user_id)
                await update.message.reply_text(Alfred_response)

        def main(self):
            app = Application.builder().token(self.TOKEN).build()
            
            # Handler para o comando /start
            app.add_handler(CommandHandler("start", self.start))

            # Handler para mensagens diretas
            app.add_handler(MessageHandler(filters.TEXT & ~filters.COMMAND, self.reply_message))

            # Handler para mensagens de canais
            app.add_handler(MessageHandler(filters.TEXT & filters.Chat(self.CHANNEL_ID), self.handle_channel_message))

            app.run_polling()